unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MyFunc, JwwGaibu, StdCtrls, ComCtrls ;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    ComboBox3: TComboBox;
    Label4: TLabel;
    ComboBox4: TComboBox;
    LabelA1: TLabel;
    LabelA2: TLabel;
    LabelA3: TLabel;
    EditA1: TEdit;
    EditA2: TEdit;
    EditA3: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    AppPath : string ;
    lgrp,lay,ltp,wid : integer ;
    c10_r,c10_h,c10_a : double ;
    c11_n : integer ;
    c12_r,c12_d : double ;
    c12_n : integer ;
    c13_a,c13_d : double ;
    c13_n : integer ;
    c14_a,c14_d : double ;
    c14_n : integer ;
    c15_d : double ;
    c15_n : integer ;
    procedure OpenDatFile ;
    procedure SaveDatFile ;
  public
    { Public 錾 }
  end;

const
   SENLEN = 100000000.0 ;    // ⏕̒

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile ;
var
   fn: string ;
   F : TextFile ;
   s : string ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   lgrp:=-1;
   lay :=-1;
   ltp := 0;
   wid :=-1;
   c10_r := 100.0;
   c10_h := 1.0;
   c10_a := 0.0;
   c11_n := 2;
   c12_r := 100.0;
   c12_d := 10.0;
   c12_n := 2;
   c13_a := 0.0;
   c13_d := 10.0;
   c13_n := 2;
   c14_a := 0.0;
   c14_d := 10.0;
   c14_n := 2;
   c15_d := 10.0;
   c15_n := 10;
   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, s);  lgrp:= SInt(s);
      ReadLn(F, s);  lay := SInt(s);
      ReadLn(F, s);  ltp := SInt(s);
      ReadLn(F, s);  wid := SInt(s);
      ReadLn(F, s);  c10_r:= SDbl(s);
      ReadLn(F, s);  c10_h:= SDbl(s);
      ReadLn(F, s);  c10_a:= SDbl(s);
      ReadLn(F, s);  c11_n:= SInt(s);
      ReadLn(F, s);  c12_r:= SDbl(s);
      ReadLn(F, s);  c12_d:= SDbl(s);
      ReadLn(F, s);  c12_n:= SInt(s);
      ReadLn(F, s);  c13_a:= SDbl(s);
      ReadLn(F, s);  c13_d:= SDbl(s);
      ReadLn(F, s);  c13_n:= SInt(s);
      ReadLn(F, s);  c14_a:= SDbl(s);
      ReadLn(F, s);  c14_d:= SDbl(s);
      ReadLn(F, s);  c14_n:= SInt(s);
      ReadLn(F, s);  c15_d:= SDbl(s);
      ReadLn(F, s);  c15_n:= SInt(s);

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile ;
var
   fn: string ;
   F : TextFile ;
begin
   fn := ChangeFileExt(Application.ExeName,'.dat') ;
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, IntToStr(lgrp));
      WriteLn(F, IntToStr(lay));
      WriteLn(F, IntToStr(ltp));
      WriteLn(F, IntToStr(wid));
      WriteLn(F, FloatToStr(c10_r));
      WriteLn(F, FloatToStr(c10_h));
      WriteLn(F, FloatToStr(c10_a));
      WriteLn(F, IntToStr(c11_n));
      WriteLn(F, FloatToStr(c12_r));
      WriteLn(F, FloatToStr(c12_d));
      WriteLn(F, IntToStr(c12_n));
      WriteLn(F, FloatToStr(c13_a));
      WriteLn(F, FloatToStr(c13_d));
      WriteLn(F, IntToStr(c13_n));
      WriteLn(F, FloatToStr(c14_a));
      WriteLn(F, FloatToStr(c14_d));
      WriteLn(F, IntToStr(c14_n));
      WriteLn(F, FloatToStr(c15_d));
      WriteLn(F, IntToStr(c15_n));

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then
         DeleteFile(fn);
   end;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
var
   i : integer ;
   w1,w2,w3,w4,w5,w7,w8,w9 : double ;
   sflag : Boolean ;
begin
   if (ParamCount >= 1) then
      Form1.WindowState := wsMinimized ;
   // ݒ
   InitJwwGaibu ;
   // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // JWC_TEMP.TXTJ܂
   OpenTempFile(AppPath+'JWC_TEMP.TXT') ;
   //
   OpenDatFile ;
   sflag := False ;
   if (ParamCount >= 1) then begin
      S_Init ;       // 
      if (lgrp = -1) then  // CO[v
         S_LGrp(JG_CurLgrp)
      else
         S_LGrp(lgrp);
      if (lay = -1) then   // C
         S_Lay(JG_CurLay)
      else
         S_Lay(lay);
      S_Col(9,0);    // F=⏕=9
      S_Ltp(ltp,1);  // 
      S_Wid(wid);    // 
      //
      if (ParamStr(1) = '/R1') then begin
         // Q_w
         w1 := JG_IPoints[1].x ;
         w2 := JG_IPoints[1].y ;
         w3 := JG_IPoints[2].x ;
         w4 := JG_IPoints[2].y ;
         w5 := Angle(w3-w1,w4-w2);  // Q_̌Xpx[rad]
         w7 := (w1+w3)/2.0 ;        // Q_̒_
         w8 := (w2+w4)/2.0 ;
         w1 := w7 + SENLEN/2.0*Cos(w5);
         w2 := w8 + SENLEN/2.0*Sin(w5);
         w3 := w7 + SENLEN/2.0*Cos(w5+Pi);
         w4 := w8 + SENLEN/2.0*Sin(w5+Pi);
         S_Line(w1,w2, w3,w4);
      end
      else if (ParamStr(1) = '/R2')
            or(ParamStr(1) = '/R3')
            or(ParamStr(1) = '/R4') then begin
         // EEpx
         w9 := JG_Jikukaku ;
         if      (ParamStr(1) = '/R3') then w9 := w9 + 90.0
         else if (ParamStr(1) = '/R4') then w9 := w9 + SDbl(ParamStr(2)) ;
         w5 := w9/180.0*Pi ;
         w7 := JG_IPoints[1].x ;
         w8 := JG_IPoints[1].y ;
         w1 := w7 + SENLEN/2.0*Cos(w5);
         w2 := w8 + SENLEN/2.0*Sin(w5);
         w3 := w7 + SENLEN/2.0*Cos(w5+Pi);
         w4 := w8 + SENLEN/2.0*Sin(w5+Pi);
         S_Line(w1,w2, w3,w4);
      end
      else if (ParamStr(1) = '/R5')
            or(ParamStr(1) = '/R6')
            or(ParamStr(1) = '/R7') then begin
         // sEEX
         if (JW_EntLineN = 0) then Close ;   // ǂݎĂȂ:ꉞ̃`FbN
         with JW_EntLine[0] do
            w9 := Angle(x2-x1,y2-y1)*180.0/Pi;
         if (w9 >= 180.0) then
            w9 := w9 - 180.0;
         if      (ParamStr(1) = '/R6') then w9 := w9 + 90.0
         else if (ParamStr(1) = '/R7') then w9 := w9 + SDbl(ParamStr(2)) ;
         w5 := w9/180.0*Pi ;
         w7 := JG_IPoints[2].x ;
         w8 := JG_IPoints[2].y ;
         w1 := w7 + SENLEN/2.0*Cos(w5);
         w2 := w8 + SENLEN/2.0*Sin(w5);
         w3 := w7 + SENLEN/2.0*Cos(w5+Pi);
         w4 := w8 + SENLEN/2.0*Sin(w5+Pi);
         S_Line(w1,w2, w3,w4);
      end
      else if (ParamStr(1) = '/R8') then begin
         // _
         w1 := JG_IPoints[1].x ;
         w2 := JG_IPoints[1].y ;
         S_PCol(9,0);
         S_Ten(w1,w2);
      end
      else if (ParamStr(1) = '/R9') then begin
         // ~P
         w1 := JG_IPoints[1].x ;
         w2 := JG_IPoints[1].y ;
         w3 := JG_IPoints[2].x ;
         w4 := JG_IPoints[2].y ;
         w5 := Dist(w1,w2,w3,w4);
         S_Circle(w1,w2,w5);
      end;
   end
   else begin
      sflag := True ;
      PageControl1.ActivePage := TabSheet2 ; // [ݒ]
   end;
   //
   LabelA1.Visible := False;  EditA1.Visible := False;
   LabelA2.Visible := False;  EditA2.Visible := False;
   LabelA3.Visible := False;  EditA3.Visible := False;
   if (ParamCount >= 1) then begin
      if (ParamStr(1) = '/R10') then begin
         // ~Q
         LabelA1.Visible := True;   EditA1.Visible := True;
         LabelA2.Visible := True;   EditA2.Visible := True;
         LabelA3.Visible := True;   EditA3.Visible := True;
         LabelA1.Caption := '@a';
         LabelA2.Caption := 'Ε';
         LabelA3.Caption := 'Xpx[]';
         EditA1.Text := FloatToStr(c10_r);
         EditA2.Text := FloatToStr(c10_h);
         EditA3.Text := FloatToStr(c10_a);
         PageControl1.ActivePage := TabSheet1 ;
         sflag := True ;
      end
      else if (ParamStr(1) = '/R11') then begin
         // _
         LabelA1.Visible := True;   EditA1.Visible := True;
         LabelA1.Caption := '';
         EditA1.Text := FloatToStr(c11_n);
         PageControl1.ActivePage := TabSheet1 ;
         sflag := True ;
      end
      else if (ParamStr(1) = '/R12') then begin
         // S~
         LabelA1.Visible := True;   EditA1.Visible := True;
         LabelA2.Visible := True;   EditA2.Visible := True;
         LabelA3.Visible := True;   EditA3.Visible := True;
         LabelA1.Caption := 'Jna';
         LabelA2.Caption := 'a';
         LabelA3.Caption := '}';
         EditA1.Text := FloatToStr(c12_r);
         EditA2.Text := FloatToStr(c12_d);
         EditA3.Text := IntToStr(c12_n);
         PageControl1.ActivePage := TabSheet1 ;
         sflag := True ;
      end
      else if (ParamStr(1) = '/R13') then begin
         // Apx
         LabelA1.Visible := True;   EditA1.Visible := True;
         LabelA2.Visible := True;   EditA2.Visible := True;
         LabelA3.Visible := True;   EditA3.Visible := True;
         LabelA1.Caption := 'pxmn';
         LabelA2.Caption := '';
         LabelA3.Caption := '}';
         EditA1.Text := FloatToStr(c13_a);
         EditA2.Text := FloatToStr(c13_d);
         EditA3.Text := IntToStr(c13_n);
         PageControl1.ActivePage := TabSheet1 ;
         sflag := True ;
      end
      else if (ParamStr(1) = '/R14') then begin
         // AX
         LabelA1.Visible := True;   EditA1.Visible := True;
         LabelA2.Visible := True;   EditA2.Visible := True;
         LabelA3.Visible := True;   EditA3.Visible := True;
         LabelA1.Caption := 'pxmn';
         LabelA2.Caption := '';
         LabelA3.Caption := '}';
         EditA1.Text := FloatToStr(c14_a);
         EditA2.Text := FloatToStr(c14_d);
         EditA3.Text := IntToStr(c14_n);
         PageControl1.ActivePage := TabSheet1 ;
         sflag := True ;
      end
      else if (ParamStr(1) = '/R15') then begin
         // Obh
         LabelA1.Visible := True;   EditA1.Visible := True;
         LabelA2.Visible := True;   EditA2.Visible := True;
         LabelA1.Caption := 'ԁ@u';
         LabelA2.Caption := '}({Б)';
         EditA1.Text := FloatToStr(c15_d);
         EditA2.Text := IntToStr(c15_n);
         PageControl1.ActivePage := TabSheet1 ;
         sflag := True ;
      end;
   end;
   //
   if (sflag) then begin
      // ݒ
      Form1.Left := Mouse.CursorPos.X - Form1.Width  div 2;
      Form1.Top  := Mouse.CursorPos.Y - Form1.Height div 2;
      Form1.WindowState := wsNormal;
      //
      ComboBox1.Items.Clear ;
      ComboBox1.Items.Add('ڲԸٰ');
      for i:=0 to 15 do
         ComboBox1.Items.Add('ڲԸٰ['+IntToHex(i,1)+']');
      ComboBox2.Items.Clear ;
      ComboBox2.Items.Add('݃C');
      for i:=0 to 15 do
         ComboBox2.Items.Add('C('+IntToHex(i,1)+')');
      ComboBox3.Items.Clear ;
      ComboBox3.Items.Add('ݐ');
      for i:=1 to 9 do
         ComboBox3.Items.Add(''+IntToStr(i));
      for i:=1 to 5 do
         ComboBox3.Items.Add('_'+IntToStr(i));
      for i:=1 to 4 do
         ComboBox3.Items.Add('{'+IntToStr(i));
      for i:=1 to 32 do
         ComboBox3.Items.Add('SXF-'+IntToStr(i));
      ComboBox4.Text := '' ;
      //
      ComboBox1.ItemIndex := lgrp + 1 ;
      ComboBox2.ItemIndex := lay  + 1 ;
      ComboBox3.ItemIndex := ltp ;
      if (wid >= 0) then
         ComboBox4.Text := IntToStr(wid);
   end
   else begin
      if (lgrp <> -1) then
         S_LGrp(JG_CurLgrp);  // CO[v߂
      if (lay <> -1) then
         S_Lay(JG_CurLay);    // C߂
      SaveDatFile ;
      Close ;
   end;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if (ParamCount >= 1) then begin
      // JWC_TEMP.TXTۑ܂
      SaveTempFile(AppPath+'JWC_TEMP.TXT') ;
   end;
   // ŏI
   EndJwwGaibu ;
end;

// [OK]
procedure TForm1.Button1Click(Sender: TObject);
var
   flag : Boolean ;
   w1,w2,w3,w4,w5,w6,w7 : double ;
   i,j,k : integer ;
begin
   lgrp:= ComboBox1.ItemIndex - 1 ;
   lay := ComboBox2.ItemIndex - 1 ;
   ltp := ComboBox3.ItemIndex ;
   if (ComboBox4.Text = '') then
      wid := -1
   else
      wid := SInt(ComboBox4.Text);
   //
   if (ParamCount >= 1) then begin
      flag := False;
      if (ParamStr(1) = '/R10') then begin
         c10_r := SDbl(EditA1.Text);
         c10_h := SDbl(EditA2.Text);
         c10_a := SDbl(EditA3.Text);
         if (c10_r <= _LIMIT) then exit;
         if (c10_h <= _LIMIT) then exit;
         while (c10_a <    0.0) do c10_a := c10_a + 360.0;
         while (c10_a >= 360.0) do c10_a := c10_a - 360.0;
         flag := True;
      end
      else if (ParamStr(1) = '/R11') then begin
         c11_n := SInt(EditA1.Text);
         if (c11_n < 2)or(c11_n > 10000) then exit;
         flag := True;
      end
      else if (ParamStr(1) = '/R12') then begin
         c12_r := SDbl(EditA1.Text);
         c12_d := SDbl(EditA2.Text);
         c12_n := SInt(EditA3.Text);
         if (c12_r <= _LIMIT) then exit;
         if (Abs(c12_d) <= _LIMIT) then exit;
         if (c12_n < 1)or(c12_n > 10000) then exit;
         flag := True;
      end
      else if (ParamStr(1) = '/R13') then begin
         c13_a := SDbl(EditA1.Text);
         c13_d := SDbl(EditA2.Text);
         c13_n := SInt(EditA3.Text);
         while (c13_a <    0.0) do c13_a := c13_a + 360.0;
         while (c13_a >= 360.0) do c13_a := c13_a - 360.0;
         if (Abs(c13_d) <= _LIMIT) then exit;
         if (c13_n < 1)or(c13_n > 10000) then exit;
         flag := True;
      end
      else if (ParamStr(1) = '/R14') then begin
         c14_a := SDbl(EditA1.Text);
         c14_d := SDbl(EditA2.Text);
         c14_n := SInt(EditA3.Text);
         while (c14_a <    0.0) do c14_a := c14_a + 360.0;
         while (c14_a >= 360.0) do c14_a := c14_a - 360.0;
         if (Abs(c14_d) <= _LIMIT) then exit;
         if (c14_n < 1)or(c14_n > 10000) then exit;
         if (JW_EntLineN = 0) then exit ;   // ǂݎĂȂ:ꉞ̃`FbN
         flag := True;
      end
      else if (ParamStr(1) = '/R15') then begin
         c15_d := SDbl(EditA1.Text);
         c15_n := SInt(EditA2.Text);
         if (Abs(c15_d) <= _LIMIT) then exit;
         if (c15_n < 1)or(c15_n > 10000) then exit;
         flag := True;
      end;
      //
      if (flag) then begin
         if (ParamStr(1) = '/R10') then begin
            w1 := JG_IPoints[1].x ;
            w2 := JG_IPoints[1].y ;
            if (Abs(c10_h-1.0) <= _LIMIT) then begin
               S_Circle(w1,w2,c10_r);
            end
            else begin
               w3 := JG_Jikukaku + c10_a ;
               S_Arc(w1,w2,c10_r,0.0,0.0,c10_h,w3);
            end;
         end
         else if (ParamStr(1) = '/R11') then begin
            SendMem('bz');       // }[h
            S_PCol(9,0);
            // f[^̕
            for i:=0 to JW_EntLineN-1 do begin
               with JW_EntLine[i] do begin
                  w1 := Dist(x1,y1,x2,y2)/c11_n;
                  w2 := Angle(x2-x1,y2-y1);
                  w3 := x1;
                  w4 := y1;
                  for j:=1 to c11_n-1 do begin
                     w3 := w3 + w1*Cos(w2);
                     w4 := w4 + w1*Sin(w2);
                     S_Ten(w3,w4);
                  end;
               end;
            end;
            // ~f[^̕
            for i:=0 to JW_EntCircN-1 do begin
               with JW_EntCirc[i] do begin
                  w2 := 0.0;
                  for j:=1 to c11_n do begin
                     w3 := cx + cr*Cos(w2);
                     w4 := cy + cr*Sin(w2);
                     S_Ten(w3,w4);
                     w2 := w2 + 2.0*Pi/c11_n ;
                  end;
               end;
            end;
            // ʁEȉ~f[^̕
            for i:=0 to JW_EntArcN-1 do begin
               with JW_EntArc[i] do begin
                  w1 := sa/180.0*Pi ;
                  w2 := ea - sa ;
                  while (w2 <=  0.0) do w2 := w2 + 360.0;
                  while (w2 > 360.0) do w2 := w2 - 360.0;
                  k := c11_n - 1 ;
                  if (Abs(w2-360.0) <= _LIMITN) then begin
                     k := c11_n;
                     w1:= 0.0;
                  end;
                  w2 := w2/c11_n/180*Pi ;
                  for j:=1 to k do begin
                     w1 := w1 + w2 ;
                     w3 := cr   *Cos(w1);
                     w4 := cr*he*Sin(w1);
                     Rev(w5,w6,w3,w4,0.0,0.0,ka);
                     w3 := cx + w5 ;
                     w4 := cy + w6 ;
                     S_Ten(w3,w4);
                  end;
               end;
            end;
         end
         else if (ParamStr(1) = '/R12') then begin
            w1 := JG_IPoints[1].x ;
            w2 := JG_IPoints[1].y ;
            w3 := c12_r ;
            for i:=1 to c12_n do begin
               S_Circle(w1,w2,w3);
               w3 := w3 + c12_d ;
               if (w3 <= _LIMIT) then break;
            end;
         end
         else if (ParamStr(1) = '/R13') then begin
            w7 := (JG_Jikukaku + c13_a)/180.0*Pi ;
            w5 := JG_IPoints[1].x ;
            w6 := JG_IPoints[1].y ;
            for i:=1 to c13_n do begin
               w1 := w5 + SENLEN/2.0*Cos(w7);
               w2 := w6 + SENLEN/2.0*Sin(w7);
               w3 := w5 + SENLEN/2.0*Cos(w7+Pi);
               w4 := w6 + SENLEN/2.0*Sin(w7+Pi);
               S_Line(w1,w2, w3,w4);
               w5 := w5 + c13_d*Cos(w7+0.5*Pi);
               w6 := w6 + c13_d*Sin(w7+0.5*Pi);
            end;
         end
         else if (ParamStr(1) = '/R14') then begin
            with JW_EntLine[0] do
               w7 := Angle(x2-x1,y2-y1)*180.0/Pi;
            if (w7 >= 180.0) then
               w7 := w7 - 180.0;
            w7 := (w7 + c14_a)/180.0*Pi ;
            w5 := JG_IPoints[2].x ;
            w6 := JG_IPoints[2].y ;
            for i:=1 to c14_n do begin
               w1 := w5 + SENLEN/2.0*Cos(w7);
               w2 := w6 + SENLEN/2.0*Sin(w7);
               w3 := w5 + SENLEN/2.0*Cos(w7+Pi);
               w4 := w6 + SENLEN/2.0*Sin(w7+Pi);
               S_Line(w1,w2, w3,w4);
               w5 := w5 + c14_d*Cos(w7+0.5*Pi);
               w6 := w6 + c14_d*Sin(w7+0.5*Pi);
            end;
         end
         else if (ParamStr(1) = '/R15') then begin
            w7 := JG_Jikukaku/180.0*Pi ;
            w5 := JG_IPoints[1].x + c15_n*c15_d*Cos(w7-0.5*Pi);
            w6 := JG_IPoints[1].y + c15_n*c15_d*Sin(w7-0.5*Pi);
            for i:=-c15_n to c15_n do begin
               w1 := w5 + c15_n*c15_d*Cos(w7);
               w2 := w6 + c15_n*c15_d*Sin(w7);
               w3 := w5 + c15_n*c15_d*Cos(w7+Pi);
               w4 := w6 + c15_n*c15_d*Sin(w7+Pi);
               if ((i mod 5) = 0) then
                  S_Ltp(ltp,1)
               else
                  S_Ltp(9,0); // TɎw^̑⏕
                S_Line(w1,w2, w3,w4);
               w5 := w5 + c15_d*Cos(w7+0.5*Pi);
               w6 := w6 + c15_d*Sin(w7+0.5*Pi);
            end;
            w7 := w7 + 0.5*Pi ;
            w5 := JG_IPoints[1].x + c15_n*c15_d*Cos(w7-0.5*Pi);
            w6 := JG_IPoints[1].y + c15_n*c15_d*Sin(w7-0.5*Pi);
            for i:=-c15_n to c15_n do begin
               w1 := w5 + c15_n*c15_d*Cos(w7);
               w2 := w6 + c15_n*c15_d*Sin(w7);
               w3 := w5 + c15_n*c15_d*Cos(w7+Pi);
               w4 := w6 + c15_n*c15_d*Sin(w7+Pi);
               if ((i mod 5) = 0) then
                  S_Ltp(ltp,1)
               else
                  S_Ltp(9,0); // TɎw^̑⏕
               S_Line(w1,w2, w3,w4);
               w5 := w5 + c15_d*Cos(w7+0.5*Pi);
               w6 := w6 + c15_d*Sin(w7+0.5*Pi);
            end;
         end;
         if (lgrp <> -1) then
            S_LGrp(JG_CurLgrp);  // CO[v߂
         if (lay <> -1) then
            S_Lay(JG_CurLay);    // C߂
      end;
   end;
   SaveDatFile ;
   Close ;
end;

// [Cancel]
procedure TForm1.Button2Click(Sender: TObject);
begin
   Close ;
end;

end.
